require 'xforum/engine'

module Xforum
    mattr_accessor :user_class
    mattr_accessor :user_table
    def self.user_class
      @@user_class.constantize
    end
    class ForumAssist

      def self.make_string_list(alist)
        plucking=''
        alist.each {|entry|
          plucking.concat(',' ) unless plucking==''
          plucking.concat(entry.to_s)
        }
        plucking
      end

      def self.named_array(data,params)
        data = Array.new(params.size,nil)  if data.nil? || data.empty?
        if  data.size==1
          double=true
          data.push(data[0])
        end
        pseudo= !data[0].is_a?(Array)
        temp=Array.new{{}}
        pseudo ? size=1 : size=data.size
        (0...size).each {|i|
          temp[i]={}
          datax=data[i]
          (0...params.size).each { |j|
            pseudo ? temp[i].store(params[j], data[j]) : temp[i].store(params[j], datax[j]) }
        }
        temp.shift if double
        temp
      end

      def self.make_last(alist,params)
        index=0
        (0...alist.size).each {|i|
          params[:key].nil? ? (index=i if alist[i]==params[:ref]) : index=i if alist[i][params[:key]]==params[:ref]
        }
        ref=alist[index]
        alist.delete_at(index)
        alist.push(ref)
        alist
      end
      def self.add_user_name(list)
        list.each { |suggestion|
          suggestion[:user]=Xforum.user_class.where(id: suggestion[:user]).pluck(:user_name)[0]
        }
        list
      end

      def self.make_first(alist,params)
        index=0
        (0...alist.size).each {|i|
          params[:key].nil? ? (index=i if alist[i]==params[:ref]) : index=i if alist[i][params[:key]]==params[:ref]
        }
        ref=alist[index]
        alist.delete_at(index)
        alist.unshift(ref)
        alist
      end

      def self.get_url(source)
        my_object=AssistMe.get_aws_object(source)
        if ENV['USE_AWS']=='true'
          my_object.url_for(:read, :expires => 60*60).to_param
        else
          File.join('http://localhost:3000',source)
        end
      end

      def self.list_files(directory)
        amazon_s3 = AWS::S3.new(
            access_key_id:ENV['XFORUM_S3_ACCESS_KEY_ID'],
            secret_access_key:ENV['XFORUM_S3_SECRET_ACCESS_KEY'])
        files=[]
        amazon_s3.buckets[ENV['XFORUM_S3_BUCKET']].objects.each{|object|
          if object.key.include?("#{directory}/")
            files.push(object.key)
          end
        }
        files
      end

      def self.get_aws_object(key,my_bucket=ENV['S3_BUCKET'])
        amazon_s3 = AWS::S3.new(
            access_key_id:ENV['XFORUM_S3_ACCESS_KEY_ID'],
            secret_access_key:ENV['XFORUM_S3_SECRET_ACCESS_KEY'])
        bucket = amazon_s3.buckets[my_bucket]
        bucket.objects[key]
      end

      def self.save_image(source, key)
        my_object=AssistMe.get_aws_object(key)
        my_object.write(Pathname.new(source))
      end
    end
end
